from Products.Archetypes.public import listTypes
from Products.Archetypes.Extensions.utils import installTypes, install_subskin
from Products.WeatherReport.config import *

from StringIO import StringIO
from Products.CMFCore.utils import getToolByName
from ZPublisher.HTTPRequest import record

# Setup title_or_id Index args
#
toi = record()
toi.indexed_fields = 'title_or_id'

catalog_indexes = (
    { 'name' : 'title_or_id',
      'type' : 'FieldIndex'
    },
                  )

def install(self):
    out = StringIO()

    installTypes(self, out,
                 listTypes(PROJECTNAME),
                 PROJECTNAME)

    install_subskin(self, out, GLOBALS)
    
    # Add a title_or_id index to the portal_catalog if it doesn't exist
    #
    catalog_tool = getToolByName(self, 'portal_catalog')
    for idx in catalog_indexes:
        if idx['name'] in catalog_tool.indexes():
            out.write("Found the '%s' index already in the catalog ... not added.\n" % idx['name'])
        else:
            catalog_tool.addIndex(**idx)
            out.write("Added '%s' (%s) to the catalog.\n" % (idx['name'], idx['type']))

    print >> out, "Successfully installed %s." % PROJECTNAME
    return out.getvalue()
